package com.simonstl.fragment;

import java.util.*;
import org.apache.xerces.utils.regex.RegularExpression;
import org.apache.xerces.utils.regex.Match;
import org.apache.regexp.*;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* RegexProc currently wraps the Apache Xerces 
* org.apache.xerces.utils.regex.RegularExpression class for
* matching, and org.apache.regexp.RE for splitting.
*
* Eventually this functionality will be extended to allow developers to plug in alternative packages
* for processing regular expressions.
*
* @version 0.01 2 July 2001
* @author Simon St.Laurent
*/


public class RegexProc {
    public String matchRegEx;
    public ArrayList results;
    boolean isSplit=false;

public RegexProc (String regEx) {
    matchRegEx=regEx;
    results=new ArrayList();
}

public void setIsSplit(boolean split) {
    isSplit=split;
}
public boolean getIsSplit() {
    return isSplit;
}


public ArrayList processString(String elementContent) {

//System.out.println("isSplit: "+isSplit);
  if (isSplit) {
     results=splitter(elementContent);
     } else {
     results=matcher(elementContent);
 }//end else of isSplit
  
return results;
}

public ArrayList matcher(String elementContent) {
   ArrayList matchResults=new ArrayList();
   RegularExpression regExProc=new RegularExpression(matchRegEx);
   Match match=new Match();
   if (regExProc.matches(elementContent, match)) {
     int numberMatches=match.getNumberOfGroups();
//System.out.println(numberMatches +" matches");
//System.out.println(numberMatches-1+" matches, start="+start);
       for (int i=0; i<numberMatches; i++) {
         String value=match.getCapturedText(i);
         matchResults.add(value);
      }//end for
 } else {
System.out.println("False claim of match!!");
   } //end else for match
return matchResults;

}

public ArrayList splitter(String elementContent) {
   ArrayList splitResults=new ArrayList();
      RE r=null;
      String pattern=matchRegEx;
      String input=elementContent;
      try {
        r=new RE(pattern);
       String[] splits=r.split(elementContent);
//System.out.println("# pieces:"+splits.length);
       for (int i=0; i<splits.length; i++) {

//System.out.println("current:"+i+ " value: "+splits[i]);
        splitResults.add(splits[i]);
       }
      } catch (RESyntaxException e) {
System.out.println("bad pattern");
      }
return splitResults;

}

}